## libime-jyutping 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(libime-jyutping VERSION 1.0.3)

find_package(ECM 1.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

#########################################
# Options
#########################################
option(ENABLE_ENGINE "Enable input method for fcitx" On)
option(ENABLE_TEST "Build Test" On)
option(ENABLE_DOC "Build doxygen" Off)

#########################################
# Dependency
#########################################

include(GNUInstallDirs)
include(FeatureSummary)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGeneratePkgConfigFile)
include(ECMUninstallTarget)

find_package(Fcitx5Utils REQUIRED)
include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")

find_package(LibIMECore REQUIRED)
find_package(Gettext REQUIRED)
find_package(Fcitx5Module REQUIRED Spell Punctuation QuickPhrase)

if(ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(po)

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== data/CMakeLists.txt ===
set(DICT_TAR "jyutping-dict-20180104.tar.xz")
set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")

set(MODEL_TAR "jyutping-model-20180103.tar.xz")
set(MODEL_URL "https://download.fcitx-im.org/data/${MODEL_TAR}")

fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
                e3a5b13edb8efa2f764245a3232f99ba7e7670e22b8cbe666a4fffa84b35f35b)
fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
                OUTPUT words.txt)

fcitx5_download(model-download ${MODEL_URL} ${MODEL_TAR}
                4f07229e2080f0ee30ce51b016409f260af82a58dd406a01ea5981b59ca87071)
fcitx5_extract(model-extract ${MODEL_TAR} DEPENDS model-download
                OUTPUT hk.arpa)

set(LM_SRC "${CMAKE_CURRENT_BINARY_DIR}/hk.arpa")
set(LM_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/zh_HK.lm")
set(LM_PREDICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/zh_HK.lm.predict")

add_custom_command(
  OUTPUT "${LM_OUTPUT}"
  DEPENDS "${LM_SRC}" LibIME::slm_build_binary
  COMMAND LibIME::slm_build_binary -s -a 22 -q 8 trie "${LM_SRC}" "${LM_OUTPUT}")
add_custom_target(model ALL DEPENDS "${LM_OUTPUT}")

add_custom_command(
  OUTPUT "${LM_PREDICT_OUTPUT}"
  DEPENDS "${LM_SRC}" model LibIME::prediction
  COMMAND LibIME::prediction "${LM_OUTPUT}" "${LM_SRC}" "${LM_PREDICT_OUTPUT}")
add_custom_target(predict ALL DEPENDS "${LM_PREDICT_OUTPUT}")

set(DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/words.txt")
set(DICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/jyutping.dict")
add_custom_command(
  OUTPUT "${DICT_OUTPUT}"
  DEPENDS "${DICT_SRC}" LibIME::jyutpingdict
  COMMAND LibIME::jyutpingdict "${DICT_SRC}" "${DICT_OUTPUT}")
add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}")
install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
install(FILES "${LM_OUTPUT}" "${LM_PREDICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")

=== src/engine/CMakeLists.txt ===
set(JYUTPING_SOURCES
    engine.cpp
)
add_library(jyutping MODULE ${JYUTPING_SOURCES})
target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping Boost::iostreams)
set_target_properties(jyutping PROPERTIES PREFIX "")
target_compile_definitions(jyutping
  PRIVATE LIBIME_INSTALL_PKGDATADIR=\"${LIBIME_INSTALL_PKGDATADIR}\"
          FCITX_GETTEXT_DOMAIN=\"fcitx5-jyutping\"
)
fcitx5_add_i18n_definition(TARGETS jyutping)

install(TARGETS jyutping DESTINATION "${CMAKE_INSTALL_LIBDIR}/fcitx5")
fcitx5_translate_desktop_file(jyutping.conf.in jyutping.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping.conf" DESTINATION "${CMAKE_INSTALL_DATADIR}/fcitx5/inputmethod")
fcitx5_translate_desktop_file(jyutping-addon.conf.in jyutping-addon.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping-addon.conf" RENAME jyutping.conf DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon")


fcitx5_translate_desktop_file(org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml.in
                              org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml XML)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml" DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

=== debian/changelog ===
libime-jyutping (1.0.3-2) unstable; urgency=medium

  * Source-only upload.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 Jul 2022 16:44:21 -0400

libime-jyutping (1.0.3-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Sun, 10 Jul 2022 10:56:20 -0400

=== debian/control ===
Source: libime-jyutping
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 extra-cmake-modules,
 fcitx5-module-punctuation-dev,
 fcitx5-modules-dev,
 gettext,
 libboost-dev,
 libboost-iostreams-dev,
 libfcitx5core-dev (>= 5.0.16~),
 libfcitx5utils-dev,
 libfmt-dev,
 libime-bin,
 libimecore-dev,
 pkg-config,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/fcitx/libime-jyutping
Vcs-Git: https://salsa.debian.org/input-method-team/libime-jyutping.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime-jyutping

Package: libime-data-jyutping
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libime-data-jyutping-language-model (>= ${source:Version}),
Description: Fcitx5 libime implementation of jyutping input method (data)
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the architecture-independent dictionary files.
 
Package: libime-data-jyutping-language-model
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: Fcitx5 libime implementation of jyutping input method (model)
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the architecture-dependent langauge model files.

Package: libimejyutping-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libimejyutping1 (= ${binary:Version}),
Description: Fcitx5 libime implementation of jyutping input method (dev)
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the library development files.

Package: libimejyutping1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libime-data-jyutping (= ${source:Version}),
Description: Fcitx5 libime implementation of jyutping input method (lib)
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the shared library files.

Package: fcitx5-jyutping
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx5 libime implementation of jyutping input method
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the jyutping input method.

Package: libime-jyutping-bin
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx5 libime implementation of jyutping input method (tools)
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.
 .
 This package provides the libime_jyutpingdict tool to handle jyutping
 dictionary.

## libime-jyutping 1.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.3)
+project(libime-jyutping VERSION 1.0.5)
 
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -28,10 +28,10 @@
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
 find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
-set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
-set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")
+set(LIBIME_JYUTPING_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
+set(LIBIME_JYUTPING_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")
 
-find_package(LibIMECore REQUIRED)
+find_package(LibIMECore 1.0.16 REQUIRED)
 find_package(Gettext REQUIRED)
 find_package(Fcitx5Module REQUIRED Spell Punctuation QuickPhrase)

=== tools/CMakeLists.txt ===

add_executable(libime_jyutpingdict libime_jyutpingdict.cpp)
target_link_libraries(libime_jyutpingdict LibIME::Jyutping)
install(TARGETS libime_jyutpingdict DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::jyutpingdict ALIAS libime_jyutpingdict)

=== src/engine/CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping Boost::iostreams)
 set_target_properties(jyutping PROPERTIES PREFIX "")
 target_compile_definitions(jyutping
-  PRIVATE LIBIME_INSTALL_PKGDATADIR=\"${LIBIME_INSTALL_PKGDATADIR}\"
-          FCITX_GETTEXT_DOMAIN=\"fcitx5-jyutping\"
+    PRIVATE LIBIME_JYUTPING_INSTALL_PKGDATADIR=\"${LIBIME_JYUTPING_INSTALL_PKGDATADIR}\"
+            FCITX_GETTEXT_DOMAIN=\"fcitx5-jyutping\"
 )
 fcitx5_add_i18n_definition(TARGETS jyutping)

=== src/libime/jyutping/CMakeLists.txt ===
ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMEJyutping
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfigVersion.cmake"
                  SOVERSION 0)

set(LIBIME_JYUTPING_HDRS
    jyutpingdictionary.h
    jyutpingencoder.h
    jyutpingdata.h
    jyutpingcontext.h
    jyutpingdecoder.h
    jyutpingime.h
    jyutpingmatchstate.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimejyutping_export.h
    )

set(LIBIME_JYUTPING_SRCS
    jyutpingencoder.cpp
    jyutpingdata.cpp
    jyutpingdictionary.cpp
    jyutpingcontext.cpp
    jyutpingdecoder.cpp
    jyutpingime.cpp
    jyutpingmatchstate.cpp
    )

add_library(IMEJyutping SHARED ${LIBIME_JYUTPING_SRCS})
set_target_properties(IMEJyutping
                      PROPERTIES VERSION ${IMEJyutping_VERSION}
                      SOVERSION ${IMEJyutping_SOVERSION}
                      EXPORT_NAME Jyutping
)
target_include_directories(IMEJyutping PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMEJyutping PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)

install(TARGETS IMEJyutping EXPORT LibIMEJyutpingTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_JYUTPING_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/jyutping")

add_library(LibIME::Jyutping ALIAS IMEJyutping)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMEJyutpingConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping"
)

generate_export_header(IMEJyutping BASE_NAME LibIMEJyutping)

install(EXPORT LibIMEJyutpingTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping" FILE LibIMEJyutpingTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping"
        COMPONENT Devel )

=== debian/changelog ===
libime-jyutping (1.0.5-1) unstable; urgency=medium

  * New upstream release.
    + Fix compatibility with libboost 1.81.
  * debian/control: Require libime (>= 1.0.16~).

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Nov 2022 14:01:01 -0500

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  libfcitx5utils-dev,
  libfmt-dev,
  libime-bin,
- libimecore-dev,
+ libimecore-dev (>= 1.0.16~),
  pkg-config,
 Rules-Requires-Root: no
 Standards-Version: 4.6.1

## libime-jyutping 1.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.5)
+project(libime-jyutping VERSION 1.0.6)
 
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

=== debian/changelog ===
libime-jyutping (1.0.6-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Jun 2023 09:56:42 -0400

## libime-jyutping 1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.6)
+project(libime-jyutping VERSION 1.0.9)
 
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -23,8 +23,18 @@
 include(ECMGenerateHeaders)
 include(ECMGeneratePkgConfigFile)
 include(ECMUninstallTarget)
+find_package(PkgConfig REQUIRED)
 
+pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")
 find_package(Fcitx5Utils REQUIRED)
+find_package(fmt REQUIRED)
+
+if (TARGET fmt::fmt-header-only)
+    set(FMT_TARGET fmt::fmt-header-only)
+else()
+    set(FMT_TARGET fmt::fmt)
+endif ()
+
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
 find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
@@ -32,8 +42,12 @@
 set(LIBIME_JYUTPING_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")
 
 find_package(LibIMECore 1.0.16 REQUIRED)
-find_package(Gettext REQUIRED)
-find_package(Fcitx5Module REQUIRED Spell Punctuation QuickPhrase)
+
+if(ENABLE_ENGINE)
+    find_package(Gettext REQUIRED)
+    find_package(Fcitx5Module REQUIRED Spell Punctuation QuickPhrase)
+    add_subdirectory(po)
+endif()
 
 if(ENABLE_TEST)
     enable_testing()
@@ -43,7 +57,6 @@
 add_subdirectory(src)
 add_subdirectory(tools)
 add_subdirectory(data)
-add_subdirectory(po)
 
 if (ENABLE_DOC)
   find_package(Doxygen REQUIRED)

=== src/engine/CMakeLists.txt ===
set(JYUTPING_SOURCES
    engine.cpp
)
add_library(jyutping MODULE ${JYUTPING_SOURCES})
target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping Boost::iostreams ${FMT_TARGET})
target_compile_definitions(jyutping
    PRIVATE LIBIME_JYUTPING_INSTALL_PKGDATADIR=\"${LIBIME_JYUTPING_INSTALL_PKGDATADIR}\"
            FCITX_GETTEXT_DOMAIN=\"fcitx5-jyutping\"
)
fcitx5_add_i18n_definition(TARGETS jyutping)

install(TARGETS jyutping DESTINATION "${CMAKE_INSTALL_LIBDIR}/fcitx5")
fcitx5_translate_desktop_file(jyutping.conf.in jyutping.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping.conf" DESTINATION "${CMAKE_INSTALL_DATADIR}/fcitx5/inputmethod" COMPONENT config)
fcitx5_translate_desktop_file(jyutping-addon.conf.in jyutping-addon.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping-addon.conf" RENAME jyutping.conf DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon" COMPONENT config)


fcitx5_translate_desktop_file(org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml.in
                              org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml XML)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.Addon.Jyutping.metainfo.xml" DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

=== debian/changelog ===
libime-jyutping (1.0.9-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Jan 2024 14:21:54 -0500

libime-jyutping (1.0.8-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Nov 2023 18:27:20 -0400

libime-jyutping (1.0.7-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 30 Sep 2023 21:26:21 -0400

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
  libfmt-dev,
  libime-bin,
  libimecore-dev (>= 1.0.16~),
+ libzstd-dev,
  pkg-config,
 Rules-Requires-Root: no
 Standards-Version: 4.6.1

## libime-jyutping 1.0.12

=== debian/changelog ===
libime-jyutping (1.0.12-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Jun 2024 19:36:16 -0400

libime-jyutping (1.0.11-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Apr 2024 01:01:39 -0400

libime-jyutping (1.0.10-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Mar 2024 22:49:32 -0400

## libime-jyutping 1.0.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.9)
+project(libime-jyutping VERSION 1.0.13)
 
+set(REQUIRED_FCITX_VERSION 5.1.12)
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 
@@ -26,7 +27,7 @@
 find_package(PkgConfig REQUIRED)
 
 pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")
-find_package(Fcitx5Utils REQUIRED)
+find_package(Fcitx5Utils  ${REQUIRED_FCITX_VERSION} REQUIRED)
 find_package(fmt REQUIRED)
 
 if (TARGET fmt::fmt-header-only)
@@ -45,6 +46,7 @@
 
 if(ENABLE_ENGINE)
     find_package(Gettext REQUIRED)
+    find_package(Fcitx5Core ${REQUIRED_FCITX_VERSION} REQUIRED)
     find_package(Fcitx5Module REQUIRED Spell Punctuation QuickPhrase)
     add_subdirectory(po)
 endif()

=== src/engine/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 set(JYUTPING_SOURCES
     engine.cpp
 )
-add_library(jyutping MODULE ${JYUTPING_SOURCES})
+add_fcitx5_addon(jyutping ${JYUTPING_SOURCES})
 target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping Boost::iostreams ${FMT_TARGET})
 target_compile_definitions(jyutping
     PRIVATE LIBIME_JYUTPING_INSTALL_PKGDATADIR=\"${LIBIME_JYUTPING_INSTALL_PKGDATADIR}\"
@@ -12,7 +12,8 @@
 install(TARGETS jyutping DESTINATION "${CMAKE_INSTALL_LIBDIR}/fcitx5")
 fcitx5_translate_desktop_file(jyutping.conf.in jyutping.conf)
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping.conf" DESTINATION "${CMAKE_INSTALL_DATADIR}/fcitx5/inputmethod" COMPONENT config)
-fcitx5_translate_desktop_file(jyutping-addon.conf.in jyutping-addon.conf)
+configure_file(jyutping-addon.conf.in.in ${CMAKE_CURRENT_BINARY_DIR}/jyutping-addon.conf.in @ONLY)
+fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/jyutping-addon.conf.in jyutping-addon.conf)
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/jyutping-addon.conf" RENAME jyutping.conf DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon" COMPONENT config)

=== debian/changelog ===
libime-jyutping (1.0.13-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Aug 2025 05:34:21 +0200

libime-jyutping (1.0.13-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Jan 2025 17:30:41 -0500

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  gettext,
  libboost-dev,
  libboost-iostreams-dev,
- libfcitx5core-dev (>= 5.0.16~),
+ libfcitx5core-dev (>= 5.1.12),
  libfcitx5utils-dev,
  libfmt-dev,
  libime-bin,

## libime-jyutping 1.0.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.13)
+project(libime-jyutping VERSION 1.0.14)
 
-set(REQUIRED_FCITX_VERSION 5.1.12)
+set(REQUIRED_FCITX_VERSION 5.1.13)
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 
@@ -28,13 +28,6 @@
 
 pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")
 find_package(Fcitx5Utils  ${REQUIRED_FCITX_VERSION} REQUIRED)
-find_package(fmt REQUIRED)
-
-if (TARGET fmt::fmt-header-only)
-    set(FMT_TARGET fmt::fmt-header-only)
-else()
-    set(FMT_TARGET fmt::fmt)
-endif ()
 
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -37,5 +37,5 @@
   DEPENDS "${DICT_SRC}" LibIME::jyutpingdict
   COMMAND LibIME::jyutpingdict "${DICT_SRC}" "${DICT_OUTPUT}")
 add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}")
-install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
-install(FILES "${LM_OUTPUT}" "${LM_PREDICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
+install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_JYUTPING_INSTALL_PKGDATADIR}")
+install(FILES "${LM_OUTPUT}" "${LM_PREDICT_OUTPUT}" DESTINATION "${LIBIME_JYUTPING_INSTALL_LIBDATADIR}")

=== po/CMakeLists.txt ===
fcitx5_install_translation(fcitx5-jyutping)

=== src/engine/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
     engine.cpp
 )
 add_fcitx5_addon(jyutping ${JYUTPING_SOURCES})
-target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping Boost::iostreams ${FMT_TARGET})
+target_link_libraries(jyutping Fcitx5::Core Fcitx5::Config Fcitx5::Module::Spell Fcitx5::Module::Punctuation Fcitx5::Module::QuickPhrase LibIME::Jyutping)
 target_compile_definitions(jyutping
     PRIVATE LIBIME_JYUTPING_INSTALL_PKGDATADIR=\"${LIBIME_JYUTPING_INSTALL_PKGDATADIR}\"
             FCITX_GETTEXT_DOMAIN=\"fcitx5-jyutping\"

=== src/libime/CMakeLists.txt ===
add_subdirectory(jyutping)

=== debian/changelog ===
libime-jyutping (1.0.14-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Move package description to source package section.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Aug 2025 18:58:11 -0400

=== debian/watch ===
version=4
opts="pgpmode=auto" \
 https://download.fcitx-im.org/fcitx5/libime-jyutping/ \
 libime-jyutping-@ANY_VERSION@_dict@ARCHIVE_EXT@ debian uupdate

## libime-jyutping 1.0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.14)
+project(libime-jyutping VERSION 1.0.15)
 
 set(REQUIRED_FCITX_VERSION 5.1.13)
 find_package(ECM 1.0 REQUIRED)

=== src/CMakeLists.txt ===
add_subdirectory(libime)

if (ENABLE_ENGINE)
add_subdirectory(engine)
endif()

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LIBIME_SINGLE_FILE_TEST
  testencoder
  testdecoder
  testdictionary
    )

foreach(TESTCASE ${LIBIME_SINGLE_FILE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} LibIME::Jyutping)
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

add_executable(testime testime.cpp)
target_link_libraries(testime LibIME::Jyutping)

=== tools/CMakeLists.txt ===

add_executable(libime_jyutpingdict libime_jyutpingdict.cpp)
target_link_libraries(libime_jyutpingdict LibIME::Jyutping)
install(TARGETS libime_jyutpingdict DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::jyutpingdict ALIAS libime_jyutpingdict)

=== src/libime/jyutping/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ecm_setup_version(PROJECT
                   VARIABLE_PREFIX IMEJyutping
                   PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfigVersion.cmake"
-                  SOVERSION 0)
+                  SOVERSION 1)
 
 set(LIBIME_JYUTPING_HDRS
     jyutpingdictionary.h
@@ -35,10 +35,10 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)
 
-target_link_libraries(IMEJyutping PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)
+target_link_libraries(IMEJyutping PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::iostreams PkgConfig::ZSTD)
 
-install(TARGETS IMEJyutping EXPORT LibIMEJyutpingTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
-install(FILES ${LIBIME_JYUTPING_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/jyutping")
+install(TARGETS IMEJyutping EXPORT LibIMEJyutpingTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT lib)
+install(FILES ${LIBIME_JYUTPING_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/jyutping" COMPONENT header)
 
 add_library(LibIME::Jyutping ALIAS IMEJyutping)
 
@@ -49,10 +49,14 @@
 
 generate_export_header(IMEJyutping BASE_NAME LibIMEJyutping)
 
-install(EXPORT LibIMEJyutpingTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping" FILE LibIMEJyutpingTargets.cmake NAMESPACE LibIME:: )
+install(EXPORT LibIMEJyutpingTargets
+        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping"
+        FILE LibIMEJyutpingTargets.cmake
+        NAMESPACE LibIME::
+        COMPONENT Devel)
 
 install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfig.cmake"
                "${CMAKE_CURRENT_BINARY_DIR}/LibIMEJyutpingConfigVersion.cmake"
         DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEJyutping"
-        COMPONENT Devel )
+        COMPONENT Devel)

=== debian/changelog ===
libime-jyutping (1.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Nov 2025 15:03:34 -0500

=== debian/control ===
Source: libime-jyutping
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 extra-cmake-modules,
 fcitx5-module-punctuation-dev,
 fcitx5-modules-dev,
 gettext,
 libboost-dev,
 libboost-iostreams-dev,
 libfcitx5core-dev (>= 5.1.13),
 libfcitx5utils-dev,
 libime-bin,
 libimecore-dev (>= 1.0.16~),
 libzstd-dev,
 pkgconf,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/fcitx/libime-jyutping
Vcs-Git: https://salsa.debian.org/input-method-team/libime-jyutping.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime-jyutping
Description: Fcitx5 libime implementation of jyutping input method
 This software provides a library that makes use of libime to implement
 jyutping (粵拼) input method. It also includes an engine for fcitx 5.

Package: libime-data-jyutping
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libime-data-jyutping-language-model (>= ${source:Version}),
Description: ${source:Synopsis} (data)
 ${source:Extended-Description}
 .
 This package provides the architecture-independent dictionary files.
 
Package: libime-data-jyutping-language-model
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} (model)
 ${source:Extended-Description}
 .
 This package provides the architecture-dependent language model files.

Package: libimejyutping-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libimejyutping1 (= ${binary:Version}),
Description: ${source:Synopsis} (dev)
 ${source:Extended-Description}
 .
 This package provides the library development files.

Package: libimejyutping1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libime-data-jyutping (= ${source:Version}),
Description: ${source:Synopsis} (lib)
 ${source:Extended-Description}
 .
 This package provides the shared library files.

Package: fcitx5-jyutping
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides the jyutping input method.

Package: libime-jyutping-bin
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (tools)
 ${source:Extended-Description}
 .
 This package provides the libime_jyutpingdict tool to handle jyutping
 dictionary.

## libime-jyutping 1.0.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime-jyutping VERSION 1.0.15)
+project(libime-jyutping VERSION 1.0.16)
 
 set(REQUIRED_FCITX_VERSION 5.1.13)
 find_package(ECM 1.0 REQUIRED)
@@ -8,9 +8,12 @@
 #########################################
 # Options
 #########################################
+option(BUILD_SHARED_LIBS "Build library as shared libs" On)
 option(ENABLE_ENGINE "Enable input method for fcitx" On)
 option(ENABLE_TEST "Build Test" On)
 option(ENABLE_DOC "Build doxygen" Off)
+option(ENABLE_DATA "Build data" On)
+option(ENABLE_TOOLS "Build tools" On)
 
 #########################################
 # Dependency
@@ -50,8 +53,12 @@
 endif()
 
 add_subdirectory(src)
-add_subdirectory(tools)
-add_subdirectory(data)
+if (ENABLE_TOOLS)
+    add_subdirectory(tools)
+endif()
+if (ENABLE_DATA)
+    add_subdirectory(data)
+endif()
 
 if (ENABLE_DOC)
   find_package(Doxygen REQUIRED)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,9 @@
 set(MODEL_TAR "jyutping-model-20180103.tar.xz")
 set(MODEL_URL "https://download.fcitx-im.org/data/${MODEL_TAR}")
 
-fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
+fcitx5_download(jyutping-dict-download ${DICT_URL} ${DICT_TAR}
                 e3a5b13edb8efa2f764245a3232f99ba7e7670e22b8cbe666a4fffa84b35f35b)
-fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
+fcitx5_extract(jyutping-dict-extract ${DICT_TAR} DEPENDS jyutping-dict-download
                 OUTPUT words.txt)
 
 fcitx5_download(model-download ${MODEL_URL} ${MODEL_TAR}
@@ -36,6 +36,6 @@
   OUTPUT "${DICT_OUTPUT}"
   DEPENDS "${DICT_SRC}" LibIME::jyutpingdict
   COMMAND LibIME::jyutpingdict "${DICT_SRC}" "${DICT_OUTPUT}")
-add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}")
+add_custom_target(jyutping-dict ALL DEPENDS "${DICT_OUTPUT}")
 install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_JYUTPING_INSTALL_PKGDATADIR}")
 install(FILES "${LM_OUTPUT}" "${LM_PREDICT_OUTPUT}" DESTINATION "${LIBIME_JYUTPING_INSTALL_LIBDATADIR}")

=== src/libime/jyutping/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
     jyutpingmatchstate.cpp
     )
 
-add_library(IMEJyutping SHARED ${LIBIME_JYUTPING_SRCS})
+add_library(IMEJyutping ${LIBIME_JYUTPING_SRCS})
 set_target_properties(IMEJyutping
                       PROPERTIES VERSION ${IMEJyutping_VERSION}
                       SOVERSION ${IMEJyutping_SOVERSION}

=== debian/changelog ===
libime-jyutping (1.0.16-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 29 Dec 2025 21:11:59 -0500

=== debian/control ===
--- 
+++ 
@@ -20,8 +20,7 @@
  libimecore-dev (>= 1.0.16~),
  libzstd-dev,
  pkgconf,
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/fcitx/libime-jyutping
 Vcs-Git: https://salsa.debian.org/input-method-team/libime-jyutping.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/libime-jyutping
